// ----------------------------------------------------------------
// Classe MooImgCombo  	-  		Mike GILBLAS  		- 	 14/06/2010 
// ----------------------------------------------------------------
// Zone combo permettant de drouler un popup contenant une liste 
//  d'images en lien avec aperu au survol
// ----------------------------------------------------------------
// Usage : 
// -------
// - inclure mooImgCombo.js dans la page
// - instancier MooImgCombo sur un input type text (elt). 
// 		new MooImgCombo(elt, options);
// Options : 
// ---------
// - repImages: Repertoire ou se trouvent les images  afficher
// - fullPath:  Boulen indiquant si on doit stocker le chemin 
//				complet du fichier image dans l'input
// ----------------------------------------------------------------

// ----------------------------------------------------------------
// Variables  prdfinir pour l'install
// 
// 		/!\  Les rpertoires sont dfinis par rapport  
// 			  la page qui inclus ce script (pour chemins absolus)
//
//		/!\  Ne pas oublier le "/"  la fin de chaque chemin
// ----------------------------------------------------------------
var repICScript = '/mooimgcombo/';					// Rpertoire ou se trouve ce script

// ----------------------------------------------------------------
// Definition de la classe
// ----------------------------------------------------------------
var MooImgCombo = new Class({
	Implements: [Events, Options],

	// ------------------------------------------------------------
	// Options
	options: {
		repImages: './',
		fullPath: true
	},
	
	// ------------------------------------------------------------
	// Constructeur
	initialize: function(element, options) {

		// Traitement des parametres
		this.setOptions(options);
		if (element.get('tag') != 'input' || element.get('type') != 'text') alert('MooImgCombo: l\'lement cible doit tre un input de type text...');
		else {
			this.eltInput = element;
			this.eltInput.set('disabled', true).setStyle('color', '#000');
			this.btnPopup = new Element('img', { src: repICScript + 'bull_down.png', alt: 'v', 
					styles: { cursor: 'pointer', height: 16, width: 16 } }).inject(element, 'after');
			this.btnPopup.addEvent('click', function(e) {
				e.stop();
				this.affImages();
			}.bind(this));
		}
	},
	
	// Affichage (ou non) de la liste des images
	affImages: function() {
		if (this.divListeImg) { 
			this.divListeImg.dispose(); this.divListeImg = null; 
			if (this.imgApercu) { this.imgApercu.dispose(); this.imgApercu = null; }
		} else {
					
			// Affichage liste des images
			var objInput = this.eltInput; var objIC = this;
			var cntScroll = objInput.getOffsetParent();			// Recherche du container ayant un overflow scroll
			while (cntScroll && (cntScroll.getStyle('overflow') != 'scroll' && cntScroll.getStyle('overflow') != 'auto')) 
				cntScroll = cntScroll.getOffsetParent();
			if (cntScroll == null) { cntScroll = $(document.body); }
			this.divListeImg = new Element('div', { 'class': 'taListe' }).inject(cntScroll); // Cration du div contenant la liste des images
			this.divListeImg.setStyles(
				{ top: (objInput.getPosition(cntScroll).y + 19), 
				  left: objInput.getPosition(cntScroll).x, width: (objInput.getSize().x - 2) }
			).show();
			
			// Rcup via php des fichiers  afficher
			new Request({ url: repICScript + 'mooImgCombo.php?files=1', method: 'post', onSuccess: function(retour) {
				objIC.divListeImg.set('html', retour);
				
				// Sur slection d'une image mise  jour du champ image
				objIC.divListeImg.getElements('.taLien').addEvent('click', function(e) { 
					e.stop();
					if (objIC.options.fullPath) objInput.set('value', this.get('href'));
					else objInput.set('value', this.get('href').substr(this.get('href').lastIndexOf("/") + 1));
					objIC.divListeImg.dispose(); objIC.divListeImg = null; 
					if (objIC.imgApercu) { objIC.imgApercu.dispose(); objIC.imgApercu = null; }
				});

				// Au survol d'un lien affichage apercu de l'image
				if (!objIC.imgApercu) objIC.imgApercu = new Element('img', { 'class': 'taImgApercu' }).inject($(document.body));
				objIC.divListeImg.getElements('.taLien').addEvent('mouseenter', function(e) {
					var fichier = this.get('href'); var extfic = fichier.substr(fichier.length - 4).toLowerCase();
					if (extfic == '.jpg' || extfic == '.gif' || extfic == '.png' || extfic == '.bmp') {
						objIC.imgApercu.setStyles({ left: e.client.x + 15, top: e.client.y + 5, height: 'auto', width: 'auto' });
						objIC.imgApercu.set('src', repICScript + 'loading.gif').show();
						var img = new Asset.image(fichier, { onload: function() { 
							var hauteur = this.height; var largeur = this.width;
							if (hauteur > 100) { var coef = this.width / this.height; hauteur = 100; largeur = hauteur * coef; }
							objIC.imgApercu.setStyles({ height: hauteur, width: largeur }).set('src', this.src);
						} });
					}
				});
				objIC.divListeImg.getElements('.taLien').addEvent('mouseleave', function(e) { objIC.imgApercu.hide(); });
				objIC.divListeImg.addEvent('mouseleave', function(e) { objIC.imgApercu.hide(); });
				
				// Ouverture des rpertoires
				objIC.divListeImg.getElements('.taDivrep').setStyle('height', 0);
				objIC.divListeImg.getElements('.taLienrep').addEvent('click', function(e) {
					e.stop();
					this.getNext('.taDivrep').setStyle('height', (this.getNext('.taDivrep').getSize().y==0?'auto':0));
				});
			} }).send('repfic=' + this.options.repImages + '&repico=' + repICScript);
		}
	}
});
